var myTabs = null;

function updateStatusEmbeddedCasterHistory()
{
	var callbacks = {
		success : function (o) {
			
			//Tabs
			if (myTabs == null)
			{
				myTabs = new YAHOO.widget.TabView("tabs");
			}
			
			//Sources
			var sources = new Array();
			var sourceInd = 0;
			
			var clients = new Array();
			var clientInd = 0;
			
			var reg = new RegExp("(\n)", "g");
			var lines = o.responseText.split(reg);
			
			for (var j in lines) {		
				var lineBuff = lines[j];
				
				if (lineBuff.length > 1) {
					var dateStart = "[", dateEnd = "]";
					
					var date = lineBuff.substring(dateStart.length, lineBuff.indexOf(dateEnd));
					var info = lineBuff.substring(lineBuff.indexOf(dateEnd) + 1, lineBuff.length);
					
					date = datetimeToCurrentTimezone(date.replace(" UTC", "Z").replace(" ", "T"));
					date = date.date + " " + date.time;
	
					//Accepted encoder on mountpoint /TEST1 from 127.0.0.1.
					var checkSourceOn = "Accepted encoder on mountpoint /";
					if (info.indexOf(checkSourceOn) != -1)
					{
						var from = " from ";
						var point = ". ";
						var mp = info.substring(checkSourceOn.length + 1, info.indexOf(from));
						var ip = info.substring(info.indexOf(from) + from.length, info.indexOf(point));
						var start = date;
						var end = "";
						var status = 1;
						
						sources[sourceInd] = {"Source":mp, "Status":status, "StartTime":start, "EndTime":end, "AddressIP":ip};
						sourceInd++;
					}
					
					//Kicking source on mountpoint [/TEST1] [127.0.0.1] [Source signed off (killed itself)] [encoder], connected for 15 hours, 58 minutes and 31 seconds, 179 bytes transfered.
					var checkSourceOff = "Kicking source on mountpoint [/";
					if (info.indexOf(checkSourceOff) != -1)
					{
						var from = "] [";
						var point = "] [";
						var mp = info.substring(checkSourceOff.length + 1, info.indexOf(from));
						var infosub = info.substring(info.indexOf(from) + from.length, info.length);
						var ip = infosub.substring(0, infosub.indexOf(point));
						var start = "";
						var end = date;
						var status = 0;
						
						for (i in sources) {
							if ((sources[i].Source == mp) && (sources[i].AddressIP == ip) && (sources[i].EndTime == "")) {
								sources[i].EndTime = end;
								sources[i].Status = status;
								start = sources[i].StartTime;
								break;
							}
						}
						
						if (start == "") {
							sources[sourceInd] = {"Source":mp, "Status":status, "StartTime":start, "EndTime":end, "AddressIP":ip};
							sourceInd++;		
						}
					}
	
					//Accepted client [gilles] from [80.10.46.60] on mountpoint [/TEST1]. 1 clients connected
					var checkClientOn = "Accepted client [";
					if (info.indexOf(checkClientOn) != -1)
					{
						var from = "] from [";
						var on = "] on mountpoint [/";
						var point = "]. ";
						var user = info.substring(checkClientOn.length + 1, info.indexOf(from));
						var ip = info.substring(info.indexOf(from) + from.length, info.indexOf(on));
						var mp = info.substring(info.indexOf(on) + on.length, info.indexOf(point));
						var start = date;
						var end = "";
						var status = 1;
						
						clients[clientInd] = {"User":user,"Source":mp, "Status":status, "StartTime":start, "EndTime":end, "AddressIP":ip};
						clientInd++;
					}
					
					//Kicking client [sophie] [10.20.2.121] on mountpoint [/TEST1] [Stream ended] [listener], connected for 1 minutes and 4 seconds, 46211 bytes transfered.
					var checkClientOff = "Kicking client [";
					if (info.indexOf(checkClientOff) != -1)
					{
						var from = "] [";
						var on = "] on mountpoint [/";
						var point = "] [";
						var user = info.substring(checkClientOff.length + 1, info.indexOf(from));
						var infosub = info.substring(info.indexOf(from) + from.length, info.length);
						var ip = infosub.substring(0, infosub.indexOf(on));
						var mp = infosub.substring(infosub.indexOf(on) + on.length, infosub.indexOf(point));
						var start = "";
						var end = date;
						var status = 0;
						
						for (i in clients) {
							if ((clients[i].User == user) && (clients[i].AddressIP == ip) && (clients[i].EndTime == "")) {
								clients[i].EndTime = end;
								clients[i].Status = status;
								start = clients[i].StartTime;
								break;
							}
						}
						
						if (start == "") {
							clients[clientInd] = {"User":user,"Source":mp, "Status":status, "StartTime":start, "EndTime":end, "AddressIP":ip};
							clientInd++;		
						}
					}
					
					//Power On/Off
					//Boot without exit => Brute
					//Exit without boot => Stop
					//Boot with exit => Fine
					//NtripCaster Version 0.1.5 Starting..
					var checkBoot = "NtripCaster Version ";
					var checkStop = "Exiting..";
					if ((info.indexOf(checkBoot) != -1) || (info.indexOf(checkStop) != -1))
					{
						var end = date;
						var status = 0;
						
						for (i in sources) {
							if (sources[i].EndTime == "") {
								sources[i].EndTime = end;
								sources[i].Status = status;
							}
						}
						
						for (i in clients) {
							if (clients[i].EndTime == "") {
								clients[i].EndTime = end;
								clients[i].Status = status;
							}
						}
					}
				}
			}
			
			for (i in sources) {
				var status = (sources[i].Status == 1) ? "connect" : "disconnect";
				sources[i].Status = '<span class="' + status + '">&nbsp;</span>';
			}
			
			for (i in clients) {
				var status = (clients[i].Status == 1) ? "connect" : "disconnect";
				clients[i].Status = '<span class="' + status + '">&nbsp;</span>';
			}
			
			//Fill Table
			var theEmbeddedCasterSourceView = new EmbeddedCasterSourceView(sources);
			
			//Fill Table
			var theEmbeddedCasterClientView = new EmbeddedCasterClientView(clients);
		},

		failure : function (o) {
			if (!YAHOO.util.Connect.isCallInProgress(o)) {
				YAHOO.log("ERROR: Async call failed!");
			}
			
			document.getElementById("EmbeddedCaster-Source-Table").innerHTML = getResource('EmbeddedCasterLog-Resource-NoLog');
			//document.getElementById("EmbeddedCaster-Client-Table").innerHTML = getResource('EmbeddedCasterLog-Resource-NoLog');
		},

		timeout : 15000,
		cache : false
	};
	
	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('GET', getStatusEmbeddedCasterLog, callbacks);
}

function EmbeddedCasterSourceView(source)
{
	// Columns definition
	var myColumnDefs = [
		{label:getResource('EmbeddedCaster-Source-Resource-Source'), key:"Source", resizeable:true},
		{label:getResource('EmbeddedCaster-Source-Resource-Status'), key:"Status", resizeable:true, className: "centered"},
		{label:getResource('EmbeddedCaster-Source-Resource-StartTime'), key:"StartTime", resizeable:true},
		{label:getResource('EmbeddedCaster-Source-Resource-EndTime'), key:"EndTime", resizeable:true},
		{label:getResource('EmbeddedCaster-Source-Resource-IP'), key:"AddressIP", resizeable:true}
	];

	// Data source
	var myDataSource = new YAHOO.util.DataSource(source);
	myDataSource.responseType = YAHOO.util.DataSource.TYPE_JSARRAY;
	myDataSource.responseSchema = {
		fields: ["Source","Status","StartTime","EndTime","AddressIP"]
	};

	// Table configs
	var myConfigs = {
		width:"auto"
	};
	
	// Localized messages
	myConfigs.MSG_EMPTY = getResource('EmbeddedCaster-Source-Resource-Empty');
	myConfigs.MSG_LOADING = getResource('EmbeddedCaster-Source-Resource-Loading');

	// Create table
	var myDataTable = new YAHOO.widget.DataTable("EmbeddedCaster-Source-Table", myColumnDefs, myDataSource, myConfigs);
}

function EmbeddedCasterClientView(source)
{
	// Columns definition
	var myColumnDefs = [
		{label:getResource('EmbeddedCaster-Client-Resource-User'), key:"User", resizeable:true},
		{label:getResource('EmbeddedCaster-Client-Resource-Source'), key:"Source", resizeable:true},
		{label:getResource('EmbeddedCaster-Client-Resource-Status'), key:"Status", resizeable:true, className: "centered"},
		{label:getResource('EmbeddedCaster-Client-Resource-StartTime'), key:"StartTime", resizeable:true},
		{label:getResource('EmbeddedCaster-Client-Resource-EndTime'), key:"EndTime", resizeable:true},
		{label:getResource('EmbeddedCaster-Client-Resource-IP'), key:"AddressIP", resizeable:true}
	];

	// Data source
	var myDataSource = new YAHOO.util.DataSource(source);
	myDataSource.responseType = YAHOO.util.DataSource.TYPE_JSARRAY;
	myDataSource.responseSchema = {
		fields: ["User","Source","Status","StartTime","EndTime","AddressIP"]
	};

	// Table configs
	var myConfigs = {
		width:"auto"
	};
	
	// Localized messages
	myConfigs.MSG_EMPTY = getResource('EmbeddedCaster-Client-Resource-Empty');
	myConfigs.MSG_LOADING = getResource('EmbeddedCaster-Source-Resource-Loading');

	// Create table
	var myDataTable = new YAHOO.widget.DataTable("EmbeddedCaster-Client-Table", myColumnDefs, myDataSource, myConfigs);
}